#!/bin/sh
# the next line restarts using wish \
#exec wish "$0" "$@"

#  
#/*      CNC1600 */
#/*    -150     DNC */

#  
#                     
#       00              NUL     Null                  //
#       02              STX     Start of Text         / /
#       03              ETX     End of Text           / /
#       04              EOT     End of Transmission   / /
#       0A              LF      Line Feed             / /
#       0D              CR      Carriage Return       / /
#       7F              US      Unit Separator        / /
#       FF                                            //
#


#=================================================
proc  checkSumCNC1600 { r s } {
#=================================================
 upvar $s sum
 set var0 0
    #scan $r "%c" var0 ;
    #set sF [expr ($sum & 01) ] ;
    #if {$sF} { set sum [expr (($sum>>1)|32768)] } else { set sum [expr ($sum>>1) ] ; }
    #set sum [expr $sum^$var0 ] ;

#    binary scan $r b* var0
#    set str1 [ format "%s" $var0 ] ;
#    set var0 [ expr ($var0 + 0x100 ) % 0x100 ]
#    set str2 [ format "%s" $var0 ] ;
#    binary scan $r b* var0
#    tk_messageBox -icon info -message "$r\n$str1\n$str2\n" -type ok ;
#
#    #set sF [expr ($r & 01) ] ;
#    #if {$sF} { set sum [expr (($sum>>1)|32768)] } else { set sum [expr ($sum>>1) ] ; }
#    set sum [expr $sum + $var0 ] ;
#    set sum [ expr ($sum + 0x100 ) % 0x100 ]

    binary scan $r b* var0 ;
    #binary scan $r c* var0 ;

    set str0 [ format "%s" $var0 ]
    set ch [ string index $str0 0]
    set strb $str0
    if {$ch=="1"} {
    	set strb "0"
    	append strb [ string range $str0 1 end ]
    }
    set str1 [ binary format b* $strb ]
    binary scan $str1 b* var0

    set var00 [expr ( $var0 + 0x100) % 0x100  ] ;

    set sum [expr ( $sum + $var0) ] ;
    set sum [expr ( $sum + 0x100) % 0x100  ] ;

    #tk_messageBox -icon info -message "c=$r ch=$ch \n str0=$str0 strb=$strb str1=$str1 \n var0=$var0 var00=$var00\n  \n sum=$sum " -type ok ;

 return 0
}


#=================================================
proc perflcnc1600 { filein fileout } {
# filein fileout numout sumout
#=================================================
 #upvar $numout g
 #upvar $sumout sum

 set rf [open "$filein" r ]
 fconfigure $rf -encoding binary -translation { binary binary } ; # auto

 set ff [open "$fileout"  w ] ;
 fconfigure $ff -encoding binary -translation { binary binary } ;#-eofchar {"" ""}

 #  
 puts  -nonewline  $ff "\x02"
 set sum  0 ;#     STX  ETX
 set g 0 ;#    STX  ETX
 #
 for { set i 1 } {$i<=10} { incr i } {
 	puts -nonewline $ff "\x00" ; incr g ;
 	checkSumCNC1600 "\x00" sum
  }

 set flerr 0 ; #  
 set ch1 [ read $rf 1 ]
 while {![eof $rf] } {

   if {$ch1=="\x03"} { set flerr -1 ; break ; }
   if {$ch1=="\x04"} { set flerr -2 ; break ; }

   if {$ch1=="\x0D"} { set ch1 [ read $rf 1 ] }

   if {$ch1=="\x0A"} {
   	puts -nonewline $ff "\r\n\x7f\x7f\x7f" ; incr g 5 ;
   	checkSumCNC1600 "\r" sum
   	checkSumCNC1600 "\n" sum
   	checkSumCNC1600 "\x7f" sum
   	checkSumCNC1600 "\x7f" sum
   	checkSumCNC1600 "\x7f" sum
    } else {
        puts -nonewline $ff $ch1 ; incr g ;
        checkSumCNC1600 $ch1 sum
   }

   set ch1 [ read $rf 1 ]

 } ;# end while
 close $rf ; # close the file

 #  
 for { set i 1 } {$i<=10} { incr i } {
 	puts -nonewline $ff "\x00" ; incr g ;
 	checkSumCNC1600 "\x00" sum
  }
 puts -nonewline $ff "\x03"

 #  
 set str [ format "%05u" $g ] ; # "%05d" "%05u"
 puts -nonewline $ff "$str"

 #  
 #1
 #set tgb [ binary format s* $sum ]
 #2
 set str [ format "%o" $sum ] ;
 #set str [binary format h2 $str1 ]
 #3
 #set wg1 [ format "%02x" $str1 ]
 #set str [ binary scan $str1 c* wg1 ];

 puts -nonewline $ff $str

 #  
 puts -nonewline $ff "\x04"
 for { set i 1 } {$i<=10} { incr i } { puts -nonewline $ff "\x00" ; }

 flush $ff ;close $ff ; # close the file
 return 0
}


#=======================================================
#  set types {
#    	{"All files"		*}
#    	{"UP  Files"            {.up} }
#    	{"PTP Files"            {.ptp} }
#    	{"DAT Files"            {.dat} }
#    	{"UPA Files"            {.upa} }
#    	{"Text files"		{.txt .doc}	}
#    	{"Text files"		{}		TEXT}
#     }
#
#   set fileName [tk_getOpenFile -title "Choose file....." -filetypes $types ]
#   if {$fileName==""} { exit ; }
#
#   set _tmp [ file rootname $fileName ]
#   append _tmp ".prf"
#   set file_dest $_tmp
#
#   set num 0
#   set sum 0
#   set tr [ perflcnc1600 $fileName $file_dest num  sum ]
#
#   set s1 [file mtime $file_dest ] ; set s2 [clock format $s1 -format "%a %b %d %H:%M:%S %Y" ] ;
#   set str0 " =" ; append str0 $file_dest ;
#   set str1 "Control summa between STX-ETX =" ;append str1 [ format "%d" $sum ] ; # "%o"
#   set str2 "\nNumber elements between STX-ETX =" ; append str2 "$num" ;
#   set str3 "\nSize File (bites) =" ; append str3 [file size $file_dest ] ;
#   set str4 "Time last change =" ; append str4 $s2 ;
#
#   tk_messageBox -icon info -message "$str0\n$str1\n$str2\n$str3\n$str4" -type ok ;
#
#   exit
#
